# SourcePath: openssl/20061016dev
%define libmaj 0
%define libmin 9
%define librel 7
%define librev l
Release: 11

%define openssldir %{sony_target_dev_lib_dir}/ssl
%define sony_target_arch debian-%{sony_target_cpu_longname}
# sony_target_cpu_longname is "powerpc" or "arm"

Summary: Secure Sockets Layer and cryptography libraries and tools
Name: sony-target-dev-openssl
%define pkgname %{sony_target_config}-dev-openssl
Version: %{libmaj}.%{libmin}.%{librel}%{librev}
Source0: openssl-%{version}.tar.gz
Patch: openssl_%{version}-2.diff.gz
Patch1: openssl-mvl-arch.diff
Patch2: mvl-openssl-xtensa.patch
Patch3: openssl-gzman.patch
Patch4: openssl-install_error.patch
Patch5: openssl-%{version}-fix_manpages-1.patch
License: Other
Distribution: %{sony_distribution}
Vendor: %{sony_vendor}
Packager: %{sony_packager}
Group: %{sony_group}
Provides: SSL
URL: http://www.openssl.org/
BuildRoot:   /var/tmp/%{name}-%{version}-root
Prefix: %{sony_cross_target_dir}
%define _docdir         %{sony_cross_target_dir}%{sony_target_dev_doc_dir}


%description
The OpenSSL Project is a collaborative effort to develop a robust,
commercial-grade, fully featured, and Open Source toolkit implementing the
Secure Sockets Layer (SSL v2/v3) and Transport Layer Security (TLS v1)
protocols as well as a full-strength general purpose cryptography library.
The project is managed by a worldwide community of volunteers that use the
Internet to communicate, plan, and develop the OpenSSL tookit and its related
documentation. 

%package -n %{pkgname}
Summary: Secure Sockets Layer and cryptography static libraries and headers
Group: %{sony_group}
# Requires: openssl

%description -n %{pkgname}
The OpenSSL Project is a collaborative effort to develop a robust,
commercial-grade, fully featured, and Open Source toolkit implementing the
Secure Sockets Layer (SSL v2/v3) and Transport Layer Security (TLS v1)
protocols as well as a full-strength general purpose cryptography library.
The project is managed by a worldwide community of volunteers that use the
Internet to communicate, plan, and develop the OpenSSL tookit and its related
documentation. 


%prep
# %target_check
%setup -q -n openssl-%{version}
%patch -p1
%patch1 -p1
%patch2 -p1

# Updated patch to include target links in doc/Makefile to fix build error
%patch3 -p1

# Fix install error for libcrypto and libssl 
%patch4 -p1


%build 
%sony_target_dev_setup
# acck, gaaagh, choke  horrible hack
perl -spi -e "s/\"gcc:/\"%{sony_target_toolprefix}gcc:/" Configure
perl -spi -e "s/which\(\"ranlib\"\)/which\(\"%{sony_target_toolprefix}ranlib\"\)/" Configure

perl util/perlpath.pl /usr/bin/perl

# Define the global setups..
%define CONFIG_FLAGS --prefix=%{sony_target_dev_prefix} --openssldir=%{sony_target_rel_lib_dir}/ssl no-idea no-mdc2 no-rc5 --openssldir=%{openssldir}

# First we build static libs...
./Configure no-shared %{CONFIG_FLAGS} %{sony_target_arch}
make -f Makefile DIRS="crypto ssl" all
mv libcrypto.a libcrypto.static
mv libssl.a libssl.static
make -f Makefile DIRS="crypto ssl" clean

# Next we build shared libs...
./Configure shared %{CONFIG_FLAGS} %{sony_target_arch}
ln -sf apps/openssl.pod crypto/crypto.pod ssl/ssl.pod doc/
make -f Makefile all

%install
rm -rf %{buildroot}
%sony_target_dev_setup

make -f Makefile  install INSTALL_PREFIX=%{buildroot}%{sony_cross_target_dir}
install -m 0644 libcrypto.static \
	%{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/libcrypto.a
install -m 0644 libssl.static \
	%{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/libssl.a

install -m 0644 fips-1.0/openssl_fips_fingerprint %{buildroot}/%{sony_cross_target_dir}%{sony_target_dev_bin_dir}/

mkdir -p %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_sysconf_dir}/ssl/
mv %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/ssl/{certs,openssl.cnf,private} \
	%{buildroot}%{sony_cross_target_dir}%{sony_target_dev_sysconf_dir}/ssl/
ln -s ../../../etc/ssl/{certs,openssl.cnf,private} \
	%{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/ssl/

cp -af lib*.so* \
	%{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}

# Fix up libs permissions.. just in case...
chmod 0644 %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/lib*

# Create the major version links
(
        cd %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}
        ln -s libcrypto.so.%{libmaj}.%{libmin}.%{librel} libcrypto.so.%{libmaj}
        ln -s libssl.so.%{libmaj}.%{libmin}.%{librel} libssl.so.%{libmaj}
        ln -s libcrypto.so.%{libmaj}.%{libmin}.%{librel} libcrypto.so
        ln -s libssl.so.%{libmaj}.%{libmin}.%{librel} libssl.so
)

# clean out unpackaged files

rm -f %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/pkgconfig/openssl.pc
rm -rf  %{buildroot}%{sony_cross_target_dir}%{sony_target_rel_data_dir}/man
rm -rf  %{buildroot}%{sony_cross_target_dir}%{sony_target_dev_data_dir}/man


%clean
rm -rf $RPM_BUILD_ROOT


%files -n %{pkgname}
%defattr(0644,root,root,0755)
### %doc CHANGES CHANGES.SSLeay LICENSE NEWS README

%attr(0755,root,root)%{sony_cross_target_dir}%{sony_target_dev_bin_dir}/c_rehash
%attr(0755,root,root)%{sony_cross_target_dir}%{sony_target_dev_bin_dir}/openssl
%attr(0755,root,root)%{sony_cross_target_dir}%{sony_target_dev_bin_dir}/openssl_fips_fingerprint
%attr(0755,root,root)%{sony_cross_target_dir}%{sony_target_dev_bin_dir}/fipsld

%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/libcrypto.so.0.9.7
%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/libssl.so.0.9.7

%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/ssl/certs
%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/ssl/lib
%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/ssl/misc
%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/ssl/openssl.cnf
%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/ssl/private

%{sony_cross_target_dir}%{sony_target_dev_sysconf_dir}/ssl/certs
%{sony_cross_target_dir}%{sony_target_dev_sysconf_dir}/ssl/openssl.cnf
%{sony_cross_target_dir}%{sony_target_dev_sysconf_dir}/ssl/private

### %doc %attr(0644,root,root) %{sony_cross_target_dir}%{sony_target_dev_man_dir}/man[157]/*



# %files -n %{pkgname}-dev
# %defattr(0644,root,root,0755)

%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/libcrypto.a
%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/libcrypto.so
%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/libcrypto.so.0
%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/libssl.a
%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/libssl.so
%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/libssl.so.0
%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/fips_premain.c
%{sony_cross_target_dir}%{sony_target_dev_lib_dir}/fips_premain.c.sha1
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/aes.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/asn1.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/asn1_mac.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/asn1t.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/bio.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/blowfish.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/bn.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/buffer.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/cast.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/comp.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/conf.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/conf_api.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/crypto.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/des.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/des_old.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/dh.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/dsa.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/dso.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/e_os2.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/ebcdic.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/ec.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/engine.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/err.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/evp.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/fips.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/fips_rand.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/fips_sha.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/hmac.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/krb5_asn.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/kssl.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/lhash.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/md2.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/md4.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/md5.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/obj_mac.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/objects.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/ocsp.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/opensslconf.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/opensslv.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/ossl_typ.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/pem.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/pem2.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/pkcs12.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/pkcs7.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/rand.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/rc2.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/rc4.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/ripemd.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/rsa.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/safestack.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/sha.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/ssl.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/ssl2.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/ssl23.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/ssl3.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/stack.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/symhacks.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/tls1.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/tmdiff.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/txt_db.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/ui.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/ui_compat.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/x509.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/x509_vfy.h
%{sony_cross_target_dir}%{sony_target_dev_include_dir}/openssl/x509v3.h
### %doc %attr(0644,root,root) %{sony_cross_target_dir}%{sony_target_dev_man_dir}/man[3]/*
### %doc LICENSE


%changelog
* Tue Oct 24 2006 Sony Corporation
- update to openssl-0.9.7l

* Fri Oct 28 2005 Sony Corporation
- Applied a patch to fix CAN-2005-2969

* Mon Jan 31 2005 Sony Corporation
- update to openssl0.9.7e

* Thu Jan 13 2005 Sony Corporation
- modify for (powerpc & arm)

* Thu Jan 13 2005 Sony Corporation
- delete tmpl pml files

* Tue Dec 21 2004 Sony Corporation
- remove LICENSE

* Tue Nov 16 2004 Sony Corporation
- 2 package -> 1 package

* Thu Nov 11 2004 Sony Corporation
- add Distribution,Vendor,Packager

* Tue Nov 10 2004 Sony Corporation
- change  Name: openssl -> Name: sony-target-dev-openssl

* Fri Nov 05 2004 Sony Corporation - dev-openssl
- Initial build.
